# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Summary:	Query Sender Policy Framework status in DNS
Name:		perl-Mail-SPF-Query
Version:	1.999.1
Release:	9.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Source0:	http://search.cpan.org/CPAN/authors/id/J/JM/JMEHNLE/mail-spf-query/Mail-SPF-Query-%{version}.tar.gz
Url:		http://search.cpan.org/dist/Mail-SPF-Query/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(Net::CIDR::Lite) >= 0.15
BuildRequires:	perl(Net::DNS) >= 0.46
BuildRequires:	perl(Sys::Hostname::Long)
BuildRequires:	perl(Test)
BuildRequires:	perl(URI::Escape)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)
Requires:	perl(Net::CIDR::Lite) >= 0.15
Requires:	perl(Net::DNS) >= 0.46
Provides:	spf

Requires(post):		/usr/sbin/alternatives
Requires(preun):	/usr/sbin/alternatives
Requires(postun):	/usr/sbin/alternatives, /usr/bin/readlink

# Filter bogus provide of perl(DirectiveSet) (rpm 4.9 onwards)
%global __provides_exclude ^perl\\(DirectiveSet\\)

%description
The SPF protocol relies on sender domains to publish a DNS whitelist of their
designated outbound mailers. Given an envelope sender, Mail::SPF::Query
determines the legitimacy of an SMTP client IP.

%prep
%setup -q -n Mail-SPF-Query-%{version}

# Filter bogus provide of perl(DirectiveSet) (prior to rpm 4.9)
%global perl_filt /bin/sh -c "%{__perl_provides} | sed -e '/^perl(DirectiveSet)/d'"
%define __perl_provides %{perl_filt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

# Set up alternatives
mv %{buildroot}%{_bindir}/spfquery		%{buildroot}%{_bindir}/spfquery.M:S:Q
mv %{buildroot}%{_bindir}/spfd			%{buildroot}%{_bindir}/spfd.M:S:Q
mv %{buildroot}%{_mandir}/man1/spfquery.1	%{buildroot}%{_mandir}/man1/spfquery.M:S:Q.1
mv %{buildroot}%{_mandir}/man1/spfd.1		%{buildroot}%{_mandir}/man1/spfd.M:S:Q.1
# Create %%ghost files for alternatives targets
touch %{buildroot}%{_bindir}/spfquery
chmod +x %{buildroot}%{_bindir}/spfquery
touch %{buildroot}%{_bindir}/spfd
chmod +x %{buildroot}%{_bindir}/spfd
touch %{buildroot}%{_mandir}/man1/spfquery.1
touch %{buildroot}%{_mandir}/man1/spfd.1

%check
# Test suite disabled because live DNS data required no longer exists
#make test

%clean
rm -rf %{buildroot}

%post
/usr/sbin/alternatives \
	--install	%{_bindir}/spfquery		spf		%{_bindir}/spfquery.M:S:Q 50 \
	--slave		%{_bindir}/spfd			spf-daemon	%{_bindir}/spfd.M:S:Q \
	--slave		%{_mandir}/man1/spfquery.1.gz	spf-man		%{_mandir}/man1/spfquery.M:S:Q.1.gz \
	--slave		%{_mandir}/man1/spfd.1.gz	spf-daemon-man	%{_mandir}/man1/spfd.M:S:Q.1.gz
exit 0

%preun
if [ $1 = 0 ]; then
	/usr/sbin/alternatives --remove spf %{_bindir}/spfquery.M:S:Q
fi

%postun
if [ "$1" -ge "1" ]; then
	spf=`readlink /etc/alternatives/spf`
	if [ "$spf" == "%{_bindir}/spfquery.M:S:Q" ]; then
		/usr/sbin/alternatives --set spf %{_bindir}/spfquery.M:S:Q
	fi
fi

%triggerpostun -- perl-Mail-SPF-Query < 1.997-3
/usr/sbin/alternatives --auto spf || :

%triggerpostun -- perl-Mail-SPF-Query < 1.998
spf=`readlink /etc/alternatives/spf`
if [ "$spf" == "%{_bindir}/spfquery.Mail::SPF::Query" ]; then
	/usr/sbin/alternatives --set spf %{_bindir}/spfquery.M:S:Q
fi
/usr/sbin/alternatives --remove spf %{_bindir}/spfquery.Mail::SPF::Query

%files
%defattr(-,root,root,-)
%doc CHANGES README* examples
%{_bindir}/spfd.M:S:Q
%{_bindir}/spfquery.M:S:Q
%ghost %{_bindir}/spfd
%ghost %{_bindir}/spfquery
%{perl_vendorlib}/Mail/
%{_mandir}/man1/spfd.M:S:Q.1.gz
%{_mandir}/man1/spfquery.M:S:Q.1.gz
%{_mandir}/man3/Mail::SPF::Query.3pm.gz
%ghost %{_mandir}/man1/spfd.1.gz
%ghost %{_mandir}/man1/spfquery.1.gz

%changelog
* Tue Jul  3 2012 Paul Howarth <paul@city-fan.org> 1.999.1-9
- BR:/R: perl(Carp)
- BR: perl(constant), perl(IO::File) and perl(Test)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> 1.999.1-8
- Rebuild for perl 5.14.1 in Rawhide
- Filter bogus provide of perl(DirectiveSet)
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 1.999.1-7
- Rebuild for perl 5.12.1 in Rawhide

* Fri May  7 2010 Paul Howarth <paul@city-fan.org> 1.999.1-6
- Fix dist tag to work with RHEL6 Beta

* Fri Feb 26 2010 Paul Howarth <paul@city-fan.org> 1.999.1-5
- Dist tag for Rawhide no longer needs special-casing

* Tue Sep 15 2009 Paul Howarth <paul@city-fan.org> 1.999.1-4
- Define RPM macros in global scope
- Disable test suite as the spf1-test.mailzone.com DNS zone required by the
  test suite no longer exists
  (http://readlist.com/lists/v2.listbox.com/spf-discuss/0/3759.html)
- %%ghost alternatives targets

* Tue Jun  5 2007 Paul Howarth <paul@city-fan.org> 1.999.1-3
- Fix dist tag for Fedora 7 onwards
- BuildRequire perl(ExtUtils::MakeMaker)
- Fix argument order for find with -depth

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> 1.999.1-2
- Fix distribution tags for development releases

* Mon Feb 27 2006 Paul Howarth <paul@city-fan.org> 1.999.1-1
- Update to 1.999.1

* Thu Feb  9 2006 Paul Howarth <paul@city-fan.org> 1.999-1
- Update to 1.999
- Issue addressed by fallback patch now fixed upstream, so patch removed
- Test suite issues resolved upstream, so test suite always runs now

* Sun Jan  1 2006 Paul Howarth <paul@city-fan.org> 1.998-1
- Update to 1.998
- Use search.cpan.org URL
- Don't use macros in paths for build-time commands, hardcode them instead
- Simplify distribution-detection
- Remove macro __perl_package for clarity
- Unconditionally remove buildroot in %%clean and %%install
- Add perl(MODULE_COMPAT_*) dependency for sensible upgrades
- s/Changes/CHANGES/
- s/sample/examples/
- Add perl(URI::Escape) buildreq
- perl(Sys::Hostname::Long) dep is unversioned
- Update fallback patch to apply against new version
- Add manpages for spfd and spfquery (using alternatives names)
- Require --with checks to enable test suite at build time
- Rename alternatives id from Mail::SPF::Query to M:S:Q

* Wed Aug 17 2005 Paul Howarth <paul@city-fan.org> 1.997-6
- s/Permitted From/Policy Framework/ in %%description
- remove redundant macro definitions
- remove redundant optimization flags for noarch package
- fix directory ownership

* Wed May 25 2005 Paul Howarth <paul@city-fan.org> 1.997-5
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST from %%doc

* Mon Aug  2 2004 Paul Howarth <paul@city-fan.org> 1.997-4
- Include sample directory as %%doc, suggested by
  Chuck Mead <csm@moongroup.com>
- Move `make test' to %%check section
- Use macros to specify locations of `alternatives' and `readlink'

* Tue Jul 27 2004 Paul Howarth <paul@city-fan.org> 1.997-3
- Even more macros
- Use `alternatives' so that the spfquery and spfd programs can co-exist
  with versions from other implementations

* Tue Jun 29 2004 Paul Howarth <paul@city-fan.org> 1.997-2
- Incorporate patch from David Lawless <lawless@spamcop.net> to ensure
  that fallback records are checked if there is a non-SPF TXT record
  present for the domain being checked

* Mon Apr 26 2004 Paul Howarth <paul@city-fan.org> 1.997-1
- Update to 1.997
- Resolver timeout patch now incorporated upstream, so removed
  from package

* Tue Apr 20 2004 Paul Howarth <paul@city-fan.org> 1.996-4
- Added patch by Joe Christy <joe@eshu.net> to shorten resolver
  timeout periods

* Wed Apr 14 2004 Paul Howarth <paul@city-fan.org> 1.996-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuilt from the source RPM
- Changed distribution-identifying macros for greater portability

* Sat Feb 28 2004 Paul Howarth <paul@city-fan.org> 1.996-2
- Removed perl-LMAP-CID2SPF dependency; this is checked at runtime

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 1.996-1
- Update to 1.996

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 1.995-2
- Increased perl-Net-DNS dependency to version 0.46 in line with Makefile.PL

* Fri Feb 27 2004 Paul Howarth <paul@city-fan.org> 1.995-1
- Update to 1.995

* Thu Feb 26 2004 Paul Howarth <paul@city-fan.org> 1.993-1
- Update to 1.993
- Added dependencies on perl-LMAP-CID2SPF and perl-Sys-Hostname-Long

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 1.991-3
- Removed bogus dependencies for Sendmail::Milter

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 1.991-2
- Unified spec file for Red Hat and Fedora Core

* Thu Jan 29 2004 Paul Howarth <paul@city-fan.org> 1.991-1.fc1
- Update to 1.991

* Mon Jan 26 2004 Paul Howarth <paul@city-fan.org> 1.99-1.fc1
- Update to 1.99

* Fri Jan 09 2004 Paul Howarth <paul@city-fan.org> 1.96-1.fc1
- Initial build
